#!/usr/bin/env python3
# -*- coding: utf-8 -*-

__author__    = "Tomas Fabian"
__copyright__ = "(c)2021 VSB-TUO, FEECS, Dept. of Computer Science"
__email__     = "tomas.fabian@vsb.cz"
__version__   = "0.1.0"


class BSPNode(object):
  """A class representing a binary space partitioning tree node."""
    
  def __init__(self, value):
    """Initialize node members."""
    self.__value = value # splitting line
    self.__left = None
    self.__right = None
  
  def depth(self):
    """Return the depth (height) of a tree counting from this node."""
    d = -1
    if self.__left:
      d = self.__left.depth()
    if self.__right:
      d = max(d, self.__right.depth())
    return d + 1
  
  def insert(self, value):
    """Insert a new node with the given value."""
    pass
  
  def traverse_inorder(self, viewer):
    """
    In-order depth first traversal gives nodes in non-decreasing order in case of BST and back-to-front in case of BSP tree.
    When calling recursive function, you need to use 'yield from' proposed in PEP 380, see https://www.python.org/dev/peps/pep-0380/.
    """
    pass
  
  def draw(self, viewer):
    """Return values sorted in non-decreasing order (back-to-front)."""
    pass


def main():
  pass


if __name__ == "__main__":
  main()
